// PaintballMutator



class PaintballMutator extends Mutator
  config( Paintball );

var name WeaponName, AmmoName;
var string WeaponString, AmmoString;
var bool bAllowTranslocator;
var bool bNoTeamBeacon;
var bool bForceNoPlayerLights;

function bool AlwaysKeep(Actor Other)
{
  if ( Other.IsA(WeaponName) || Other.IsA(AmmoName) )
  {
    return true;
  }

  if ( NextMutator != None )
  {
    return ( NextMutator.AlwaysKeep(Other) );
  }
  return false;
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
  if ( Other.IsA('Weapon') )
  {
    if ( Other.IsA('BallLauncher') )
    {
      bSuperRelevant = 0;
      return true;
    }

    if ( Other.IsA('TransLauncher') && bAllowTranslocator )
    {
      bSuperRelevant = 0;
      return true;
    }

    if ( !Other.IsA(WeaponName) )
    {
      Level.Game.bWeaponStay = false;
      return false;
    }
  }

  // Keep all the tournament items and charger bases. Don't keep the weapon
  // bases, since there are no weapons

  if( ( Other.IsA( 'TournamentPickUp' ) ) ||
      ( Other.IsA( 'HealthCharger' ) ) ||
      ( Other.IsA( 'SuperHealthCharger' ) ) ||
      ( Other.IsA( 'UDamageCharger') ) ||
      ( Other.IsA( 'ShieldCharger' ) ) ||
      ( Other.IsA( 'SuperShieldCharger' ) ) )
  {
    return true;
  }

  if( Other.IsA( 'Ammo' ) )
  {
    if( !Other.IsA( AmmoName ) )
    {
      ReplaceWith(Other, AmmoString);
      return false;
    }
  }

  if( Other.IsA('Pickup') )
  {
    return false;
  }

  if ( Other.IsA('xPickupBase') )
  {
    return false;
  }

  bSuperRelevant = 0;
  return true;
}

function ModifyPlayer(Pawn Other)
{
	local xPawn x;
	x = xPawn(Other);

	if(x != None)
	{
		// Remove multijump
		x.MaxMultiJump = 0;

		// Make sure of no super jumping
		x.MultiJumpBoost = 0;

		// Remove Previous multiple jumps
		x.MultiJumpRemaining = 0;

		// Get Rid of Team Beacon
		x.bNoTeamBeacon = True;

		// And Reduce Jump Height
		x.JumpZ = 120.000;
		
		level.game.gorelevel = 9;
	}
    	Super.ModifyPlayer(Other);
}

defaultproperties
{
	WeaponName="Inpulse"
     	AmmoName="InpulseAmmoPickup"
     	WeaponString="Paintball.inpulse"
     	AmmoString="Paintball.inpulseAmmoPickup"
     	DefaultWeaponName="Paintball.Inpulse"
     	GroupName="Paintball"
     	FriendlyName="Paintball"
     	Description="Replaces all weapons and ammo with an Inpulse and it's ammo, unjump"
}